#pragma once

#include <cstdint>
#include <thread>
#include "protocol.h"

struct TransactionTask
{
    const Transaction *transaction;
};

struct ValidationTask
{
    const ValidationQueries *validation;
};

struct FlushTask
{
    uint64_t firstValidationId;
    volatile uint32_t *validationExistences;
    volatile uint32_t *validationResults;
};

struct ForgetTask
{
    uint64_t transactionId;
};

struct Task
{
    union
    {
        TransactionTask transaction;
        ValidationTask validation;
        FlushTask flush;
        ForgetTask forget;
    };
    enum class Type
    {
        Transaction,
        Validation,
        Flush,
        Forget
    };
    Type type;
};
